futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Optimise.InliningDeadFun

Description

This module implements a compiler pass for inlining functions, then removing those that have become dead.

Synopsis

- inlineAggressively :: Pass SOACS SOACS
- inlineConservatively :: Pass SOACS SOACS
- removeDeadFunctions :: Pass SOACS SOACS

# Documentation

inlineAggressively :: Pass SOACS SOACS Source #

Inline all functions and remove the resulting dead functions.

inlineConservatively :: Pass SOACS SOACS Source #

Inline some functions and remove the resulting dead functions.

removeDeadFunctions :: Pass SOACS SOACS Source #

`removeDeadFunctions prog` removes the functions that are unreachable from the main function from the program.